#!/usr/bin/perl
# 
# Fixed Xbase stat and open dbf routine.  Has proper field names and stats concur.  8/9/98 KAM
# Began Create routine. 8/9/98 KAM
# Finished Create routine. 8/11/98 KAM
# Wrote num_fields routine. 8/11/98 KAM

use Xbase;
use Mysql;

################
#Check Args    #
################
if ($#ARGV < 1) {
	print "IMPORT DBF to SQL v0.50\nERROR: Not Enough Arguments!\n\nArgument 1: DBF File to Convert\nArgument 2: Database to Add To\nArgument 3: Table to Add To\nArgument 4: (Optional) 'create' creates database table -- WARNING! If the table already exists, then program exits!\n";
	exit;
}

################
#Process       #
################
process($ARGV[0], $ARGV[1], $ARGV[2], $ARGV[3]);  #pass filename and database to add to

sub process {
	local($file_to_process, $databaseto, $tableto, $create) = @_;

	print("Taking input from: $file_to_process\nAdding to Database: $databaseto\nAdding to Table: $tableto\n");

	$database = new Xbase;

	$database->open_dbf("$file_to_process") || die "Can't open $file_to_process!\n";

	if (lc($create) eq "create") {
		$dbh = Mysql->connect('', $databaseto)|| die("connect died because of: $Mysql::db_errstr");
		$query = $database->sql_create($tableto)."\n";
               	$sth = $dbh->query($query);
               	if(!$sth) {
                       	$errormsg = $dbh->errmsg;
                       	print "error: $errormsg\n";
                       	print "query: $query\n";
                       	exit();
		}
	}

	$end=$database->lastrec;

	print $database->dbf_stat;

	print "\n\nTotal Records: $end\n\n";

	$dbh = Mysql->connect('', $databaseto)|| die("connect died because of: $Mysql::db_errstr");
	$i = 0;
	while ($i < $end) {
		$temp = "";
		@fields = $database->get_record;
		
		foreach $keyitem (@fields) {
			$keyitem =~ s/\"/\"\"/g;
		}

		$j = 0;

		while ($j < $database->sql_num_fields) {
			#USE THIS AREA FOR KNOWN DATABASE ERRORS.  A FIELD THAT SAYS BoB and SHOULD BE BOB for example KAM 8-14-98 ADD ARGUMENT HERE FOR THIS	
			#if ($fields[$j] eq "Skunkette unc\\") {
			#	$temp .= "\"Skunkette unc\"";	
			#} else {
				$temp .= "\"$fields[$j]\"";
			#}
			if ($j != ($database->sql_num_fields - 1)) {
				$temp .= ",";
			}
			$j++;
		}

		$query = "insert into $tableto values ($temp)\n";

		$sth = $dbh->query($query); 
		if(!$sth) {
  	 		$errormsg = $dbh->errmsg;
  			print "error: $errormsg\n";
  			print "query: $query\n";
			exit();
		}

		$database->go_next;
		$i++;

		# Jon's Way
		print "Processing Record# $i -- ".($end - $i)." Records Left!\n" if $i =~ /00$/; 

		# Kevin's Way
		#if (index(($i/100),".") == -1) {
		#	print "Processing Record# $i\n";
		#}
	}

	$database->close_dbf;
	print "\nDatabase Closed!\n";
}
